%define anolis_release 4
# let -devel require drivers to make them available as multilib
%global needs_multilib_quirk 1

%global _hardened_build 1

%global libusb1 1

%global __provides_exclude_from ^%{_libdir}/sane/.*\.so.*$
%global __requires_exclude ^libsane-.*\.so\.[0-9]*(\(\).*)?+$

%global _maindocdir %{_docdir}/%{name}
%global _docdocdir %{_docdir}/%{name}-doc

%global scanner_backends_list abaton agfafocus apple artec artec_eplus48u as6e avision bh canon canon630u canon_dr canon_lide70 canon_pp cardscan coolscan coolscan2 coolscan3 dell1600n_net dll epjitsu epson epson2 epsonds fujitsu genesys gt68xx hp hp3500 hp3900 hp4200 hp5400 hp5590 hpljm1005 hpsj5s hs2p ibm kodak kodakaio kvs1025 kvs20xx kvs40xx leo lexmark ma1509 magicolor matsushita microtek microtek2 mustek mustek_pp mustek_usb mustek_usb2 nec net niash p5 pie pieusb pixma plustek plustek_pp ricoh ricoh2 rts8891 s9036 sceptre sharp sm3600 sm3840 snapscan sp15c st400 tamarack teco1 teco2 teco3 test u12 umax umax1220u umax_pp xerox_mfp
%global camera_backends_list dc210 dc240 dc25 dmc gphoto2 qcam stv680 v4l
%global config_files_list abaton agfafocus apple artec artec_eplus48u avision bh canon canon630u canon_dr canon_lide70 canon_pp cardscan coolscan coolscan2 coolscan3 dell1600n_net dll epjitsu epson epson2 epsonds fujitsu genesys gt68xx hp hp3900 hp4200 hp5400 hpsj5s hs2p ibm kodak kodakaio kvs1025 leo lexmark ma1509 magicolor matsushita microtek microtek2 mustek mustek_pp mustek_usb nec net p5 pie pieusb pixma plustek plustek_pp ricoh rts8891 s9036 sceptre sharp sm3840 snapscan sp15c st400 tamarack teco1 teco2 teco3 test u12 umax umax1220u umax_pp xerox_mfp dc210 dc240 dc25 dmc gphoto2 qcam stv680 v4l

Summary: Scanner access software
Name: sane-backends
Version: 1.2.1
Release: %{anolis_release}%{dist}
# lib/ is LGPLv2+, backends are GPLv2+ with exceptions
# Tools are GPLv2+, docs are public domain
# see LICENSE for details
License: GPLv2+ and GPLv2+ with exceptions and Public Domain and IJG and LGPLv2+ and MIT
# GitLab Download URLs are amazing. But the source code link has different name and doesnt have generated autotools stuff
Source0: https://gitlab.com/sane-project/backends/uploads/110fc43336d0fb5e514f1fdc7360dd87/%{name}-%{version}.tar.gz

Source1: sane.png
Source2: saned.socket
Source3: saned@.service.in
Source5: 66-saned.rules
Source6: sane-backends.sysusers

Patch1: sane-genesys-plustek7600i-8100-support.patch

URL: http://www.sane-project.org

# we need autoconf during build
BuildRequires: autoconf
BuildRequires: gettext
# gcc is no longer in buildroot by default
BuildRequires: gcc
# genesys backend is written in C++, so it is needed as buildrequire
BuildRequires: gcc-c++
# for autosetup
BuildRequires: git-core
BuildRequires: gphoto2-devel
BuildRequires: texlive-base
BuildRequires: libieee1284-devel
BuildRequires: libjpeg-devel
BuildRequires: libpng-devel
BuildRequires: libtiff-devel
%if %libusb1
BuildRequires: libusbx-devel
%else
BuildRequires: libusb-devel
%endif
BuildRequires: libv4l-devel
# uses make
BuildRequires: make
# pixma backend generates header files during build via python script
BuildRequires: python3
BuildRequires: systemd-devel
BuildRequires: systemd
# needed by macros in rpm scriptlets
BuildRequires: systemd-rpm-macros

Requires: libpng
Requires: sane-airscan
Requires: sane-backends-libs = %{?epoch:%{epoch}:}%{version}-%{release}
Requires: systemd >= 196
Requires: systemd-udev >= 196

# workaround for Brother scanners, which drivers are built with old libnsl
# it is ignored by DNF, but it seems GUI installation apps should offer it
# if it is not installed, it leads to crashes like #1778425
Suggests: libnsl

%description
Scanner Access Now Easy (SANE) is a universal scanner interface.  The
SANE application programming interface (API) provides standardized
access to any raster image scanner hardware (flatbed scanner,
hand-held scanner, video and still cameras, frame-grabbers, etc.).

%package libs
Summary: SANE libraries
Recommends: %{name}-drivers-cameras = %{?epoch:%{epoch}:}%{version}-%{release}
Recommends: %{name}-drivers-scanners = %{?epoch:%{epoch}:}%{version}-%{release}

%description libs
This package contains the SANE libraries which are needed by applications that
want to access scanners.

%package devel
Summary: SANE development toolkit
Requires: libieee1284-devel
Requires: libjpeg-devel
Requires: libtiff-devel
%if %libusb1
Requires: libusbx-devel
%else
Requires: libusb-devel
%endif
Requires: pkgconfig
Requires: sane-backends = %{?epoch:%{epoch}:}%{version}-%{release}
%if %needs_multilib_quirk
Requires: sane-backends-drivers-scanners = %{?epoch:%{epoch}:}%{version}-%{release}
Requires: sane-backends-drivers-cameras = %{?epoch:%{epoch}:}%{version}-%{release}
%endif
Requires: sane-backends-libs = %{?epoch:%{epoch}:}%{version}-%{release}

%description devel
This package contains libraries and header files for writing Scanner Access Now
Easy (SANE) modules.

%package drivers-scanners
Summary: SANE backend drivers for scanners
# pixma backend now requires libxml2
BuildRequires: libxml2-devel
# due move of camera backends
Conflicts: %{name}-drivers-cameras < 1.1.1-4
Requires: sane-backends = %{?epoch:%{epoch}:}%{version}-%{release}
Requires: sane-backends-libs = %{?epoch:%{epoch}:}%{version}-%{release}

%description drivers-scanners
This package contains backend drivers to access scanner hardware through SANE.

%package drivers-cameras
Summary: Scanner backend drivers for digital cameras
# due move of camera backends
Conflicts: %{name}-drivers-scanners < 1.1.1-4
Requires: sane-backends = %{?epoch:%{epoch}:}%{version}-%{release}
Requires: sane-backends-libs = %{?epoch:%{epoch}:}%{version}-%{release}

%description drivers-cameras
This package contains backend drivers to access digital cameras through SANE.

%package daemon
Summary: Scanner network daemon
Requires: sane-backends = %{?epoch:%{epoch}:}%{version}-%{release}
Requires: sane-backends-libs = %{?epoch:%{epoch}:}%{version}-%{release}

%description daemon
This package contains saned which is the daemon that allows remote clients to
access image acquisition devices available on the local host.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -S git

%build
CFLAGS="%optflags -fno-strict-aliasing"
%if ! 0%{?_hardened_build}
# use PIC/PIE because SANE-enabled software is likely to deal with data coming
# from untrusted sources (client <-> saned via network)
CFLAGS="$CFLAGS -fPIC"
LDFLAGS="-pie"
%endif
%configure \
    --with-gphoto2=%{_prefix} \
    --with-docdir=%{_maindocdir} \
    --with-systemd \
    --disable-locking --disable-rpath \
%if %libusb1
    --with-usb \
%endif
    --enable-pthread
%make_build

# Write udev/hwdb files
_topdir="$PWD"
pushd tools
./sane-desc -m udev+hwdb -s "${_topdir}/doc/descriptions:${_topdir}/doc/descriptions-external" -d0 > udev/sane-backends.rules
./sane-desc -m hwdb -s "${_topdir}/doc/descriptions:${_topdir}/doc/descriptions-external" -d0 > udev/sane-backends.hwdb

popd

%install
%make_install

install -p -D -m 0644 %{SOURCE6} %{buildroot}%{_sysusersdir}/sane-backends.conf

mkdir -p %{buildroot}%{_datadir}/pixmaps
install -m 644 %{SOURCE1} %{buildroot}%{_datadir}/pixmaps
rm -f %{buildroot}%{_bindir}/gamma4scanimage
rm -f %{buildroot}%{_mandir}/man1/gamma4scanimage.1*
rm -f %{buildroot}%{_libdir}/sane/*.a %{buildroot}%{_libdir}/*.a
rm -f %{buildroot}%{_libdir}/libsane*.la %{buildroot}%{_libdir}/sane/*.la

mkdir -p %{buildroot}%{_udevrulesdir}
mkdir -p %{buildroot}%{_udevhwdbdir}
install -m 0644 tools/udev/sane-backends.rules %{buildroot}%{_udevrulesdir}/65-sane-backends.rules
install -m 0644 tools/udev/sane-backends.hwdb %{buildroot}%{_udevhwdbdir}/20-sane-backends.hwdb
install -m 0644 %{SOURCE5} %{buildroot}%{_udevrulesdir}/66-saned.rules

mkdir -p %{buildroot}%{_libdir}/pkgconfig
install -m 0644 tools/sane-backends.pc %{buildroot}%{_libdir}/pkgconfig/

mkdir %{buildroot}%{_docdocdir}
pushd %{buildroot}%{_maindocdir}
for f in *; do
    if [ -d "$f" ]; then
        mv "$f" "%{buildroot}%{_docdocdir}/${f}"
    else
        case "$f" in
        AUTHORS|ChangeLog|COPYING|LICENSE|NEWS|PROBLEMS|README|README.linux)
            ;;
        backend-writing.txt|PROJECTS|sane-*.html)
            mv "$f" "%{buildroot}%{_docdocdir}/${f}"
            ;;
        *)
            rm -rf "$f"
            ;;
        esac
    fi
done
popd

install -m 755 -d %{buildroot}%{_unitdir}
install -m 644 %{SOURCE2} %{buildroot}%{_unitdir}
sed 's|@CONFIGDIR@|%{_sysconfdir}/sane.d|g' < %{SOURCE3} > saned@.service
install -m 644 saned@.service %{buildroot}%{_unitdir}

%find_lang %name

touch so_scanner_list
for backend in %scanner_backends_list
do
  echo "%{_libdir}/sane/libsane-${backend}.so" >> so_scanner_list
done

touch so_camera_list
for backend in %camera_backends_list
do
  if [ "$backend" == "qcam" ]
  then
    continue
  fi
  echo "%{_libdir}/sane/libsane-${backend}.so" >> so_camera_list
done

touch config_list
for config in %config_files_list
do
  if [ "$config" == "epsonds" ] || [ "$config" == "qcam" ]
  then
    continue
  fi
  echo "%config(noreplace) %{_sysconfdir}/sane.d/${config}.conf" >> config_list
done

%generate_compatibility_deps

%post
udevadm hwdb --update >/dev/null 2>&1 || :

# check if there is autodiscovery enabled in epsonds.conf
autodiscovery=`%{_bindir}/grep -E '^[[:space:]]*net[[:space:]]*autodiscovery' /etc/sane.d/epsonds.conf`
if [ -n "$autodiscovery" ]
then
  # comment out 'net autodiscovery' if it is not commented out
  %{_bindir}/sed -i 's,^[[:space:]]*net[[:space:]]*autodiscovery,#net autodiscovery,g' /etc/sane.d/epsonds.conf
fi

%postun
udevadm hwdb --update >/dev/null 2>&1 || :

%pre daemon
%sysusers_create_compat %{SOURCE6}

%post daemon
%systemd_post saned.socket

%preun daemon
%systemd_preun saned.socket

%postun daemon
%systemd_postun_with_restart saned.socket

%files -f %{name}.lang -f config_list
%dir %{_maindocdir}
%dir %{_sysconfdir}/sane.d
%dir %{_sysconfdir}/sane.d/dll.d
# 2130997 - epsonds.conf is modified during %post scriptlet to disable autodiscovery for
# security reasons, so disable RPM verification of it for size, md5 and modification time
%config(noreplace) %verify(not size md5 mtime) %{_sysconfdir}/sane.d/epsonds.conf
%ifarch x86_64
%config(noreplace) %{_sysconfdir}/sane.d/qcam.conf
%endif
%{_udevrulesdir}/65-sane-backends.rules
%{_udevhwdbdir}/20-sane-backends.hwdb
%{_datadir}/pixmaps/sane.png

%{_bindir}/sane-find-scanner
%{_bindir}/scanimage
%{_bindir}/umax_pp
%{abidir}/sane-find-scanner-option.list
%{abidir}/saned-option.list
%{abidir}/umax_pp-option.list

%exclude %{_mandir}/man1/sane-config.1*
%exclude %{_mandir}/man8/saned*
%{_mandir}/*/*

%dir %{_libdir}/sane
%dir %{_datadir}/sane
%license %{_maindocdir}/COPYING
%license %{_maindocdir}/LICENSE

%files libs
%{_libdir}/libsane.so.1
%{_libdir}/libsane.so.1.2.1
%dir %{abidir}
%{abidir}/libsane.dump

%files devel
%{_bindir}/sane-config
%{_mandir}/man1/sane-config.1*
%{_includedir}/sane
%{_libdir}/libsane.so
%{_libdir}/pkgconfig/sane-backends.pc

%files drivers-scanners
%{_libdir}/sane/libsane-abaton.so*
%{_libdir}/sane/libsane-agfafocus.so*
%{_libdir}/sane/libsane-apple.so*
%{_libdir}/sane/libsane-artec_eplus48u.so*
%{_libdir}/sane/libsane-artec.so*
%{_libdir}/sane/libsane-as6e.so*
%{_libdir}/sane/libsane-avision.so*
%{_libdir}/sane/libsane-bh.so*
%{_libdir}/sane/libsane-canon630u.so*
%{_libdir}/sane/libsane-canon_dr.so*
%{_libdir}/sane/libsane-canon_lide70.so*
%{_libdir}/sane/libsane-canon_pp.so*
%{_libdir}/sane/libsane-canon.so*
%{_libdir}/sane/libsane-cardscan.so*
%{_libdir}/sane/libsane-coolscan2.so*
%{_libdir}/sane/libsane-coolscan3.so*
%{_libdir}/sane/libsane-coolscan.so*
%{_libdir}/sane/libsane-dell1600n_net.so*
%{_libdir}/sane/libsane-dll.so*
%{_libdir}/sane/libsane-epjitsu.so*
%{_libdir}/sane/libsane-epson2.so*
%{_libdir}/sane/libsane-epsonds.so*
%{_libdir}/sane/libsane-epson.so*
%{_libdir}/sane/libsane-fujitsu.so*
%{_libdir}/sane/libsane-genesys.so*
%{_libdir}/sane/libsane-gt68xx.so*
%{_libdir}/sane/libsane-hp3500.so*
%{_libdir}/sane/libsane-hp3900.so*
%{_libdir}/sane/libsane-hp4200.so*
%{_libdir}/sane/libsane-hp5400.so*
%{_libdir}/sane/libsane-hp5590.so*
%{_libdir}/sane/libsane-hpljm1005.so*
%{_libdir}/sane/libsane-hpsj5s.so*
%{_libdir}/sane/libsane-hp.so*
%{_libdir}/sane/libsane-hs2p.so*
%{_libdir}/sane/libsane-ibm.so*
%{_libdir}/sane/libsane-kodakaio.so*
%{_libdir}/sane/libsane-kodak.so*
%{_libdir}/sane/libsane-kvs1025.so*
%{_libdir}/sane/libsane-kvs20xx.so*
%{_libdir}/sane/libsane-kvs40xx.so*
%{_libdir}/sane/libsane-leo.so*
%{_libdir}/sane/libsane-lexmark.so*
%{_libdir}/sane/libsane-ma1509.so*
%{_libdir}/sane/libsane-magicolor.so*
%{_libdir}/sane/libsane-matsushita.so*
%{_libdir}/sane/libsane-microtek2.so*
%{_libdir}/sane/libsane-microtek.so*
%{_libdir}/sane/libsane-mustek_pp.so*
%{_libdir}/sane/libsane-mustek.so*
%{_libdir}/sane/libsane-mustek_usb2.so*
%{_libdir}/sane/libsane-mustek_usb.so*
%{_libdir}/sane/libsane-nec.so*
%{_libdir}/sane/libsane-net.so*
%{_libdir}/sane/libsane-niash.so*
%{_libdir}/sane/libsane-p5.so*
%{_libdir}/sane/libsane-pie.so*
%{_libdir}/sane/libsane-pieusb.so*
%{_libdir}/sane/libsane-pixma.so*
%{_libdir}/sane/libsane-plustek_pp.so*
%{_libdir}/sane/libsane-plustek.so*
%{_libdir}/sane/libsane-ricoh2.so*
%{_libdir}/sane/libsane-ricoh.so*
%{_libdir}/sane/libsane-rts8891.so*
%{_libdir}/sane/libsane-s9036.so*
%{_libdir}/sane/libsane-sceptre.so*
%{_libdir}/sane/libsane-sharp.so*
%{_libdir}/sane/libsane-sm3600.so*
%{_libdir}/sane/libsane-sm3840.so*
%{_libdir}/sane/libsane-snapscan.so*
%{_libdir}/sane/libsane-sp15c.so*
%{_libdir}/sane/libsane-st400.so*
%{_libdir}/sane/libsane-tamarack.so*
%{_libdir}/sane/libsane-teco1.so*
%{_libdir}/sane/libsane-teco2.so*
%{_libdir}/sane/libsane-teco3.so*
%{_libdir}/sane/libsane-test.so*
%{_libdir}/sane/libsane-u12.so*
%{_libdir}/sane/libsane-umax1220u.so*
%{_libdir}/sane/libsane-umax_pp.so*
%{_libdir}/sane/libsane-umax.so*
%{_libdir}/sane/libsane-xerox_mfp.so*
%{abidir}/libsane-abaton.dump
%{abidir}/libsane-agfafocus.dump
%{abidir}/libsane-apple.dump
%{abidir}/libsane-artec_eplus48u.dump
%{abidir}/libsane-artec.dump
%{abidir}/libsane-as6e.dump
%{abidir}/libsane-avision.dump
%{abidir}/libsane-bh.dump
%{abidir}/libsane-canon630u.dump
%{abidir}/libsane-canon_dr.dump
%{abidir}/libsane-canon_lide70.dump
%{abidir}/libsane-canon_pp.dump
%{abidir}/libsane-canon.dump
%{abidir}/libsane-cardscan.dump
%{abidir}/libsane-coolscan2.dump
%{abidir}/libsane-coolscan3.dump
%{abidir}/libsane-coolscan.dump
%{abidir}/libsane-dell1600n_net.dump
%{abidir}/libsane-dll.dump
%{abidir}/libsane-epjitsu.dump
%{abidir}/libsane-epson2.dump
%{abidir}/libsane-epsonds.dump
%{abidir}/libsane-epson.dump
%{abidir}/libsane-fujitsu.dump
%{abidir}/libsane-genesys.dump
%{abidir}/libsane-gt68xx.dump
%{abidir}/libsane-hp3500.dump
%{abidir}/libsane-hp3900.dump
%{abidir}/libsane-hp4200.dump
%{abidir}/libsane-hp5400.dump
%{abidir}/libsane-hp5590.dump
%{abidir}/libsane-hpljm1005.dump
%{abidir}/libsane-hpsj5s.dump
%{abidir}/libsane-hp.dump
%{abidir}/libsane-hs2p.dump
%{abidir}/libsane-ibm.dump
%{abidir}/libsane-kodakaio.dump
%{abidir}/libsane-kodak.dump
%{abidir}/libsane-kvs1025.dump
%{abidir}/libsane-kvs20xx.dump
%{abidir}/libsane-kvs40xx.dump
%{abidir}/libsane-leo.dump
%{abidir}/libsane-lexmark.dump
%{abidir}/libsane-ma1509.dump
%{abidir}/libsane-magicolor.dump
%{abidir}/libsane-matsushita.dump
%{abidir}/libsane-microtek2.dump
%{abidir}/libsane-microtek.dump
%{abidir}/libsane-mustek_pp.dump
%{abidir}/libsane-mustek.dump
%{abidir}/libsane-mustek_usb2.dump
%{abidir}/libsane-mustek_usb.dump
%{abidir}/libsane-nec.dump
%{abidir}/libsane-net.dump
%{abidir}/libsane-niash.dump
%{abidir}/libsane-p5.dump
%{abidir}/libsane-pie.dump
%{abidir}/libsane-pieusb.dump
%{abidir}/libsane-pixma.dump
%{abidir}/libsane-plustek_pp.dump
%{abidir}/libsane-plustek.dump
%{abidir}/libsane-ricoh2.dump
%{abidir}/libsane-ricoh.dump
%{abidir}/libsane-rts8891.dump
%{abidir}/libsane-s9036.dump
%{abidir}/libsane-sceptre.dump
%{abidir}/libsane-sharp.dump
%{abidir}/libsane-sm3600.dump
%{abidir}/libsane-sm3840.dump
%{abidir}/libsane-snapscan.dump
%{abidir}/libsane-sp15c.dump
%{abidir}/libsane-st400.dump
%{abidir}/libsane-tamarack.dump
%{abidir}/libsane-teco1.dump
%{abidir}/libsane-teco2.dump
%{abidir}/libsane-teco3.dump
%{abidir}/libsane-test.dump
%{abidir}/libsane-u12.dump
%{abidir}/libsane-umax1220u.dump
%{abidir}/libsane-umax_pp.dump
%{abidir}/libsane-umax.dump
%{abidir}/libsane-xerox_mfp.dump

%files drivers-cameras

%ifarch x86_64
%{_libdir}/sane/*qcam.so*
%{abidir}/*qcam.dump
%endif

%{_libdir}/sane/*dc210.so*
%{_libdir}/sane/*dc240.so*
%{_libdir}/sane/*dc25.so*
%{_libdir}/sane/*dmc.so*
%{_libdir}/sane/*gphoto2.so*
%{_libdir}/sane/*stv680.so*
%{_libdir}/sane/*v4l.so*
%{abidir}/*dc210.dump
%{abidir}/*dc240.dump
%{abidir}/*dc25.dump
%{abidir}/*dmc.dump
%{abidir}/*gphoto2.dump
%{abidir}/*stv680.dump
%{abidir}/*v4l.dump

%files daemon
%{_sbindir}/saned
%{_mandir}/man8/saned*
%config(noreplace) %{_sysconfdir}/sane.d/saned.conf
%{_sysusersdir}/sane-backends.conf
%{_udevrulesdir}/66-saned.rules
%{_unitdir}/saned.socket
%{_unitdir}/saned@.service

%files doc
%doc %{_docdocdir}
%doc %{_maindocdir}/README*
%doc %{_maindocdir}/AUTHORS
%doc %{_maindocdir}/ChangeLog
%doc %{_maindocdir}/NEWS
%doc %{_maindocdir}/PROBLEMS

%changelog
* Tue Dec 12 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.2.1-4
- rebuild

* Wed Apr 05 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.2.1-3
- recover to require sane-airscan

* Wed Apr 05 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.2.1-2
- remove Requires of sane-airscan temporarily to build sane-airscan

* Thu Mar 16 2023 Zhongling He <zhonglingh@linux.alibaba.com> - 1.2.1-1
- Init package from upstream
